# PIC16C84 ASM(PASS 2) (by Y.Ikushima)
BEGIN{ cnfc = 0; datc = 0; ln = 0; err = 0; }
{
	if (ln == 0) { sfn = $1; ln ++; next; } #\[Xt@C擾

	#R}hoCiɕϊ
	if ($3 == "ADDWF")	{	opcode = 1792 + d_code($5) + f_code($4); }
	if ($3 == "ANDWF")	{	opcode = 1280 + d_code($5) + f_code($4); }
	if ($3 == "CLRF")	{	opcode = 384 + f_code($4); }
	if ($3 == "CLRW")	{	opcode = 256; }
	if ($3 == "COMF")	{	opcode = 2304 + d_code($5) + f_code($4); }
	if ($3 == "DECF")	{	opcode = 768 + d_code($5) + f_code($4); }
	if ($3 == "DECFSZ")	{	opcode = 2816 + d_code($5) + f_code($4); }
	if ($3 == "INCF")	{	opcode = 2560 + d_code($5) + f_code($4); }
	if ($3 == "INCFSZ")	{	opcode = 3840 + d_code($5) + f_code($4); }
	if ($3 == "IORWF")	{	opcode = 1024 + d_code($5) + f_code($4); }
	if ($3 == "MOVF")	{	opcode = 2048 + d_code($5) + f_code($4); }
	if ($3 == "MOVWF")	{	opcode = 128 + f_code($4); }
	if ($3 == "NOP")	{	opcode = 0; }
	if ($3 == "RLF")	{	opcode = 3328 + d_code($5) + f_code($4); }
	if ($3 == "RRF")	{	opcode = 3072 + d_code($5) + f_code($4); }
	if ($3 == "SUBWF")	{	opcode = 512 + d_code($5) + f_code($4); }
	if ($3 == "SWAPF")	{	opcode = 3584 + d_code($5) + f_code($4); }
	if ($3 == "XORWF")	{	opcode = 1536 + d_code($5) + f_code($4); }

	if ($3 == "BCF")	{	opcode = 4096 + b_code($5) + f_code($4); }
	if ($3 == "BSF")	{	opcode = 5120 + b_code($5) + f_code($4); }
	if ($3 == "BTFSC")	{	opcode = 6144 + b_code($5) + f_code($4); }
	if ($3 == "BTFSS")	{	opcode = 7168 + b_code($5) + f_code($4); }

	if ($3 == "ADDLW")	{	opcode = 15872 + ks_code($4); }
	if ($3 == "ANDLW")	{	opcode = 14592 + ks_code($4); }
	if ($3 == "CALL")	{	opcode = 8192 + kl_code($4); }
	if ($3 == "CLRWDT")	{	opcode = 100; }
	if ($3 == "GOTO")	{	opcode = 10240 + kl_code($4); }
	if ($3 == "IORLW")	{	opcode = 14336 + ks_code($4); }
	if ($3 == "MOVLW")	{	opcode = 12288 + ks_code($4); }
	if ($3 == "RETFIE")	{	opcode = 9; }
	if ($3 == "RETLW")	{	opcode = 13312 + ks_code($4); }
	if ($3 == "RETURN")	{	opcode = 8; }
	if ($3 == "SLEEP")	{	opcode = 99; }
	if ($3 == "SUBLW")	{	opcode = 15360 + ks_code($4); }
	if ($3 == "XORLW")	{	opcode = 14848 + ks_code($4); }

	#RtBO[VEq[Yihcj
	if ($1 == "#CNF") {
		cnfc ++;
		cnfad[cnfc] = $2;	#AhX
		cnfdat[cnfc] = $3;	#f[^ioCij
	}
	#f[^E
	if ($1 == "#DAT") {
		datc ++;
		datad[datc] = $2;	#AhX
		datdat[datc] = $3;	#f[^ioCij
	}
	#AhXƃR}hioCij\
	if(($1 != "#DEF")&&($1 != "#LBL")&&($1 != "#CNF")&&($1 != "#DAT")) {
		#ߍsȊÕ\[XEt@Cs\
		while(ln != $1) {
			getline slsit < sfn;	#\[XEt@CPsǂݍ
			printf("%4d                          ; %s\n",ln,slsit);
			ln ++;
		}
		printf("%4d  ",ln);	#\[XEt@C̍sԍ\
		printf("%03X ",$2);	#AhXPUi\
		pr_code(opcode);	#f[^Qi\
		getline slsit < sfn;
		printf("      ; %s\n",slsit);	#ߍs̃\[XEt@Cs\
		ln ++;
	}
}
END{
	#RtBO[VEq[Y̕\
	if (cnfc != 0) {
		printf("CONFIG\n");				#؂"CONFIG"̕\
		for(ci =1 ; ci <= cnfc ; ci ++) {
			printf("%03X ",(cnfad[ci] - 2000));	#AhX0000hɕύX
			printf("%s\n",cnfdat[ci]);
		}
	}
	#f[^̕\
	if (datc != 0) {
		printf("DATA\n");				#؂"DATA"̕\
		for(di =1 ; di <= datc ; di ++) {
			printf("0%s ",datad[di]);		#AhXPUiRɓ
			pr_code(ks_code(datdat[di]));	#f[^PSrbgɊg
			printf("\n");
		}
	}
	printf("END\n");	#R[hI̕\

	if(err == 1) {
		exit(1);
	}
}
#[U`֐
#f[^QiPSŕ\
function pr_code(ad){
	m_ad = 8192;
	for(i = 0 ; i <= 13 ; i ++) {
		if(ad >= m_ad) {
			ad = ad - m_ad ; printf("1");
		} else { printf("0"); }
		m_ad /= 2;
	}
}
#wq̃R[h
function d_code(d){
	if (d == 1) { return(128); }
	if (d == 0) { return(0); }
	err = 1;
	printf("<-------- ERROR :wqs\n");
	return(0);
}
#WX^̃rbgEAhX̃R[h
function b_code(f){
	i = length(f);
	d = dej(substr(f,i,1));
	if ((i != 1) || (d > 7)) { 
		err = 1;
		printf("<-------- ERROR :rbgEAhXs\n");
	}
	return(d*128);
}
#WX^Et@C̃R[h
function f_code(f){
	i = length(f);
	d = dej(substr(f,i-1,1)) * 16 + dej(substr(f,i,1));
	if(i != 2) {
		err = 1;
		printf("<-------- ERROR :WX^Et@Cs\n");
	}
	return(d);
}
#萔f[^̃R[h
function ks_code(f){
	i = length(f);
	d = dej(substr(f,i-1,1)) * 16 + dej(substr(f,i,1));
	if ( i != 2 ) {
		err = 1;
		printf("<-------- ERROR :萔f[^s\n");
	}
	return(d);
}
#WvEAhX̃R[h
function kl_code(kl){
	if ( kl >= 1024 ) {
		err = 1;
		printf("<-------- ERROR :WvEAhXs\n");
	}
	return(kl);
}
#PUiPOiɕϊ
function dej(s){
	d =index("0123456789ABCDEF",s);
	if (d == 0) {
		err = 1;
		printf("<-------- ERROR :PUis\n");
	}
	return(d - 1);
}
